2011-08-12 11:51:28 +04:00
#!/bin/sh -e
2014-06-26 08:22:49 +04:00
# Since we run with '#!/bin/sh -e'
# '$? != 0' will force an exit,
# i.e. where we are interested in the result of a command,
# we have to run the command in an if-statement.
2011-07-18 14:36:59 +04:00
2017-12-05 18:53:25 +03:00
ORIGIN = ${ GLUSTER_ORIGIN :- origin }
2014-08-19 00:45:21 +04:00
while getopts "v" opt; do
case $opt in
v)
# Verbose mode
2016-01-09 07:49:24 +03:00
git ( ) { >& 2 echo " git $@ " && ` which git` $@ ; }
2014-08-19 00:45:21 +04:00
; ;
esac
done
# Move the positional arguments to the beginning
shift $(( OPTIND-1))
2019-02-06 03:59:13 +03:00
branch = "release-6" ;
2011-07-18 14:36:59 +04:00
2011-08-12 11:51:28 +04:00
set_hooks_commit_msg( )
2011-07-18 14:36:59 +04:00
{
f = ".git/hooks/commit-msg" ;
2016-01-14 17:57:47 +03:00
u = "http://review.gluster.org/tools/hooks/commit-msg" ;
2011-07-18 14:36:59 +04:00
if [ -x " $f " ] ; then
return ;
fi
2016-01-14 17:57:47 +03:00
curl -L -o $f $u || wget -O $f $u ;
2011-07-18 14:36:59 +04:00
2016-01-14 17:57:47 +03:00
chmod +x $f
2012-08-07 11:14:43 +04:00
# Let the 'Change-Id: ' header get assigned on first run of rfc.sh
GIT_EDITOR = true git commit --amend;
2011-07-18 14:36:59 +04:00
}
2011-08-12 11:51:28 +04:00
is_num( )
2011-07-18 14:36:59 +04:00
{
local num;
num = " $1 " ;
[ -z " $( echo $num | sed -e 's/[0-9]//g' ) " ]
}
2017-04-05 21:22:57 +03:00
backport_id_message( )
{
echo ""
echo "This commit is to a non-master branch, and hence is treated as a backport."
echo ""
echo "For backports we would like to retain the same gerrit Change-Id across"
echo "branches. On auto inspection it is found that a gerrit Change-Id is"
echo "missing, or the Change-Id is not found on your local master"
echo ""
echo "This could mean a few things:"
echo " 1. This is not a backport, hence choose Y on the prompt to proceed"
2017-12-05 18:53:25 +03:00
echo " 2. Your $ORIGIN master is not up to date, hence the script is unable "
2017-04-05 21:22:57 +03:00
echo " to find the corresponding Change-Id on master. Either choose N,"
echo " 'git fetch', and try again, OR if you are sure you used the"
echo " same Change-Id, choose Y at the prompt to proceed"
echo " 3. You commented or removed the Change-Id in your commit message after"
echo " cherry picking the commit. Choose N, fix the commit message to"
echo " use the same Change-Id as master (git commit --amend), resubmit"
echo ""
}
check_backport( )
{
moveon = 'N'
# Backports are never made to master
if [ $branch = "master" ] ; then
return ;
fi
# Extract the change ID from the commit message
2018-09-05 06:40:39 +03:00
changeid = $( git log -n1 --format= '%b' | grep -i '^Change-Id: ' | awk '{print $2}' )
2017-04-05 21:22:57 +03:00
# If there is no change ID ask if we should continue
if [ -z " $changeid " ] ; then
backport_id_message;
echo -n "Did not find a Change-Id for a possible backport. Continue (y/N): "
read moveon
else
# Search master for the same change ID (rebase_changes has run, so we
# should never not find a Change-Id)
2017-12-05 18:53:25 +03:00
mchangeid = $( git log $ORIGIN /master --format= '%b' --grep= " ^Change-Id: ${ changeid } " | grep ${ changeid } | awk '{print $2}' )
2017-04-05 21:22:57 +03:00
# Check if we found the change ID on master, else throw a message to
# decide if we should continue.
# NOTE: If master was not rebased, we will not find the Change-ID and
# could hit a false positive case here (or if someone checks out some
# other branch as master).
2017-05-30 10:40:50 +03:00
if [ " ${ mchangeid } " = " ${ changeid } " ] ; then
2017-04-05 21:22:57 +03:00
moveon = "Y"
else
backport_id_message;
echo " Change-Id of commit: $changeid "
echo " Change-Id on master: $mchangeid "
echo -n "Did not find mentioned Change-Id on master for a possible backport. Continue (y/N): "
read moveon
fi
fi
if [ " ${ moveon } " = 'Y' ] || [ " ${ moveon } " = 'y' ] ; then
return ;
else
exit 1
fi
}
2011-07-18 14:36:59 +04:00
2011-08-12 11:51:28 +04:00
rebase_changes( )
2011-07-18 14:36:59 +04:00
{
2017-12-05 18:53:25 +03:00
GIT_EDITOR = $0 git rebase -i $ORIGIN /$branch ;
2011-07-18 14:36:59 +04:00
}
2011-08-12 11:51:28 +04:00
editor_mode( )
2011-07-18 14:36:59 +04:00
{
if [ $( basename " $1 " ) = "git-rebase-todo" ] ; then
2011-08-12 08:43:07 +04:00
sed 's/^pick /reword /g' " $1 " > $1 .new && mv $1 .new $1 ;
2011-07-18 14:36:59 +04:00
return ;
fi
if [ $( basename " $1 " ) = "COMMIT_EDITMSG" ] ; then
2018-02-14 01:41:24 +03:00
# see note above function warn_reference_missing for regex elaboration
# Lets first check for github issues
2018-09-05 06:40:39 +03:00
ref = $( git log -n1 --format= '%b' | grep -ow -E "([fF][iI][xX][eE][sS]|[uU][pP][dD][aA][tT][eE][sS])(:)?[[:space:]]+(gluster\/glusterfs)?#[[:digit:]]+" | awk -F '#' '{print $2}' ) ;
2018-02-14 01:41:24 +03:00
if [ " x ${ ref } " = "x" ] ; then
# if not found, check for bugs
2018-09-05 06:40:39 +03:00
ref = $( git log -n1 --format= '%b' | grep -ow -E "([fF][iI][xX][eE][sS]|[uU][pP][dD][aA][tT][eE][sS])(:)?[[:space:]]+bz#[[:digit:]]+" | awk -F '#' '{print $2}' ) ;
2018-02-14 01:41:24 +03:00
fi
if [ " x ${ ref } " != "x" ] ; then
2011-07-18 14:36:59 +04:00
return ;
fi
2018-02-14 01:41:24 +03:00
2011-07-18 14:36:59 +04:00
while true; do
echo Commit: " \" $( head -n 1 $1 ) \" "
2018-02-14 01:41:24 +03:00
echo -n "Reference (Bugzilla ID or Github Issue ID): "
2011-07-18 14:36:59 +04:00
read bug
if [ -z " $bug " ] ; then
return ;
fi
if ! is_num " $bug " ; then
2018-02-14 01:41:24 +03:00
echo " Invalid reference ID ( $bug )!!! " ;
2011-07-18 14:36:59 +04:00
continue ;
fi
2018-02-14 01:41:24 +03:00
bz_string = "bz"
if [ $bug -lt 742000 ] ; then
bz_string = ""
fi
echo "Select yes '(y)' if this patch fixes the bug/feature completely,"
echo -n "or is the last of the patchset which brings feature (Y/n): "
read fixes
fixes_string = "fixes"
if [ " ${ fixes } " = 'N' ] || [ " ${ fixes } " = 'n' ] ; then
fixes_string = "updates"
fi
sed " /^Change-Id:/{p; s/^.* $/ ${ fixes_string } : ${ bz_string } # ${ bug } /;} " $1 > $1 .new && \
2011-08-12 11:51:28 +04:00
mv $1 .new $1 ;
2011-07-18 14:36:59 +04:00
return ;
done
fi
cat <<EOF
$0 - editor_mode called on unrecognized file $1 with content:
$( cat $1 )
EOF
return 1;
}
2011-08-12 11:51:28 +04:00
assert_diverge( )
2011-07-18 14:36:59 +04:00
{
2017-12-05 18:53:25 +03:00
git diff $ORIGIN /$branch ..HEAD | grep -q .;
2011-07-18 14:36:59 +04:00
}
2015-04-12 18:23:55 +03:00
2014-06-26 08:22:49 +04:00
check_patches_for_coding_style( )
{
2017-12-05 18:53:25 +03:00
git fetch $ORIGIN ;
2014-06-26 08:22:49 +04:00
2016-09-05 12:39:10 +03:00
check_patch_script = ./build-aux/checkpatch.pl
if [ ! -e ${ check_patch_script } ] ; then
echo " ${ check_patch_script } is not executable .. abort "
2014-06-26 08:22:49 +04:00
exit 1
fi
2015-04-12 18:23:55 +03:00
# The URL of our Gerrit server
export GERRIT_URL = "review.gluster.org"
2014-06-26 08:22:49 +04:00
echo "Running coding guidelines check ..."
head = $( git rev-parse --abbrev-ref HEAD)
# Kludge: "1>&2 && echo $? || echo $?" is to get around
# "-e" from script invocation
2017-12-05 18:53:25 +03:00
RES = $( git format-patch --stdout $ORIGIN /${ branch } ..${ head } \
2017-07-10 18:13:39 +03:00
| ${ check_patch_script } --strict --terse - 1>& 2 && echo $? || echo $? )
2014-06-26 08:22:49 +04:00
if [ " $RES " -eq 1 ] ; then
echo "Errors caught, get details by:"
2017-12-05 18:53:25 +03:00
echo " git format-patch --stdout $ORIGIN / ${ branch } .. ${ head } \\ "
2017-07-10 18:13:39 +03:00
echo " | ${ check_patch_script } --strict --gerrit-url ${ GERRIT_URL } - "
2014-06-26 08:22:49 +04:00
echo "and correct errors"
exit 1
elif [ " $RES " -eq 2 ] ; then
2017-07-10 18:13:39 +03:00
echo "Warnings or checks caught, get details by:"
2017-12-05 18:53:25 +03:00
echo " git format-patch --stdout $ORIGIN / ${ branch } .. ${ head } \\ "
2017-07-10 18:13:39 +03:00
echo " | ${ check_patch_script } --strict --gerrit-url ${ GERRIT_URL } - "
2014-06-26 08:22:49 +04:00
echo -n "Do you want to continue anyway [no/yes]: "
read yesno
if [ " ${ yesno } " != "yes" ] ; then
echo "Aborting..."
exit 1
fi
fi
}
2011-07-18 14:36:59 +04:00
2018-02-14 01:41:24 +03:00
# Regex elaborated:
# grep -w -> --word-regexp (from the man page)
# Select only those lines containing matches that form whole words.
# The test is that the matching substring must either be at the
# beginning of the line, or preceded by a non-word constituent
# character. Similarly, it must be either at the end of the line or
# followed by a non-word constituent character. Word-constituent
# characters are letters, digits, and the underscore.
# IOW, the above helps us find the pattern with leading or training spaces
# or non word consituents like , or ;
#
# [fF][iI][xX][eE][sS]|[uU][pP][dD][aA][tT][eE][sS])
# Finds 'fixes' OR 'updates' in any case combination
#
# (:)?
# Followed by an optional : (colon)
#
# [[:space:]]+
# followed by 1 or more spaces
#
# (gluster\/glusterfs)?
# Followed by 0 or more gluster/glusterfs
#
# #
# Followed by #
#
# [[:digit:]]+
# Followed by 1 or more digits
warn_reference_missing( )
2017-04-10 18:36:17 +03:00
{
echo ""
2018-02-14 01:41:24 +03:00
echo "=== Missing a reference in commit! ==="
echo ""
echo "Gluster commits are made with a reference to a bug or a github issue"
2017-04-10 18:36:17 +03:00
echo ""
2018-02-14 01:41:24 +03:00
echo "Submissions that are enhancements (IOW, not functional"
2017-04-10 18:36:17 +03:00
echo "bug fixes, but improvements of any nature to the code) are tracked"
2018-02-14 01:41:24 +03:00
echo "using github issues [1]."
2017-04-10 18:36:17 +03:00
echo ""
2018-02-14 01:41:24 +03:00
echo "Submissions that are bug fixes are tracked using Bugzilla [2]."
2017-04-10 18:36:17 +03:00
echo ""
2018-02-14 01:41:24 +03:00
echo "A check on the commit message, reveals that there is no bug or"
echo "github issue referenced in the commit message"
2017-04-10 18:36:17 +03:00
echo ""
echo "[1] https://github.com/gluster/glusterfs/issues/new"
2018-02-14 01:41:24 +03:00
echo "[2] https://bugzilla.redhat.com/enter_bug.cgi?product=GlusterFS"
echo ""
echo "Please file an issue or a bug report and reference the same in the"
echo "commit message using the following tags:"
echo "GitHub Issues:"
echo "\"Fixes: gluster/glusterfs#n\" OR \"Updates: gluster/glusterfs#n\","
echo "\"Fixes: #n\" OR \"Updates: #n\","
echo "Bugzilla ID:"
echo "\"Fixes: bz#n\" OR \"Updates: bz#n\","
echo "where n is the issue or bug number"
2017-04-10 18:36:17 +03:00
echo ""
echo "You may abort the submission choosing 'N' below and use"
echo "'git commit --amend' to add the issue reference before posting"
2018-02-14 01:41:24 +03:00
echo "to gerrit."
2017-04-10 18:36:17 +03:00
echo ""
2018-02-14 01:41:24 +03:00
echo -n "Missing reference to a bug or a github issue. Continue (y/N): "
read moveon
if [ " ${ moveon } " = 'Y' ] || [ " ${ moveon } " = 'y' ] ; then
return ;
else
exit 1
2017-04-10 18:36:17 +03:00
fi
}
2015-04-12 18:23:55 +03:00
2011-08-12 11:51:28 +04:00
main( )
2011-07-18 14:36:59 +04:00
{
2013-08-15 03:11:40 +04:00
set_hooks_commit_msg;
2017-04-05 21:22:57 +03:00
# rfc.sh calls itself from rebase_changes, which uses rfc.sh as the EDITOR
# thus, getting the commit message to work with in the editor_mode.
2011-07-18 14:36:59 +04:00
if [ -e " $1 " ] ; then
editor_mode " $@ " ;
return ;
fi
2018-08-22 10:01:48 +03:00
# check_patches_for_coding_style
2014-06-26 08:22:49 +04:00
2011-07-18 14:36:59 +04:00
rebase_changes;
2017-04-05 21:22:57 +03:00
check_backport;
2011-07-18 14:36:59 +04:00
assert_diverge;
2018-02-14 01:41:24 +03:00
# see note above function warn_reference_missing for regex elaboration
2018-09-05 06:40:39 +03:00
reference = $( git log -n1 --format= '%b' | grep -ow -E "([fF][iI][xX][eE][sS]|[uU][pP][dD][aA][tT][eE][sS])(:)?[[:space:]]+(gluster\/glusterfs)?(bz)?#[[:digit:]]+" | awk -F '#' '{print $2}' ) ;
2011-07-18 14:36:59 +04:00
2018-02-14 01:41:24 +03:00
# If this is a commit against master and does not have a bug ID or a github
# issue reference. Warn the contributor that one of the 2 is required
if [ -z " ${ reference } " ] && [ $branch = "master" ] ; then
warn_reference_missing;
2017-04-10 18:36:17 +03:00
fi
2018-08-22 10:01:48 +03:00
# TODO: add clang-format command here. It will after the changes are done everywhere else
clang_format = $( clang-format --version)
if [ ! -z " ${ clang_format } " ] ; then
# Considering git show may not give any files as output matching the
# criteria, good to tell script not to fail on error
set +e
list_of_files = $( git show --pretty= "format:" --name-only |
grep -v "contrib/" | egrep --color= never " *\.[ch] $" ) ;
if [ ! -z " ${ list_of_files } " ] ; then
echo " ${ list_of_files } " | xargs clang-format -i
fi
set -e
else
echo "High probability of your patch not passing smoke due to coding standard check"
echo "Please install 'clang-format' to format the patch before submitting"
fi
2011-07-23 08:03:18 +04:00
if [ " $DRY_RUN " = 1 ] ; then
drier = 'echo -e Please use the following command to send your commits to review:\n\n'
else
drier =
fi
2018-02-14 01:41:24 +03:00
if [ -z " ${ reference } " ] ; then
2017-12-05 18:53:25 +03:00
$drier git push $ORIGIN HEAD:refs/for/$branch /rfc;
2011-07-18 14:36:59 +04:00
else
2018-02-14 01:41:24 +03:00
$drier git push $ORIGIN HEAD:refs/for/$branch /ref-${ reference } ;
2011-07-18 14:36:59 +04:00
fi
}
main " $@ "